# MPI_Dist_graph_neighbors

Provides adjacency information for a distributed graph topology.

## Synopsis

    int MPI_Dist_graph_neighbors(MPI_Comm comm,
                                 int maxindegree, int sources[], int sourceweights[],
                                 int maxoutdegree, int destinations[], int destweights[])

## Input Parameters

comm
  communicator with distributed graph topology (handle)
maxindegree
  size of sources and sourceweights arrays (non-negative integer)
maxoutdegree
  size of destinations and destweights arrays (non-negative integer)

## Output Parameters

sources
  processes for which the calling process is a destination (array of non-negative integers)
sourceweights
  weights of the edges into the calling process (array of non-negative integers)
destinations
  processes for which the calling process is a source (array of non-negative integers)
destweights
  weights of the edges out of the calling process (array of non-negative integers)

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.